//+------------------------------------------------------------------+
//|                                                      HedgeEA.mq4 |
//|                                 Copyright  2006, ForexForums.org|
//+------------------------------------------------------------------+

//first v  used code from (EA's by Igorad,waltini) by kokas,cturner
//v5.0 latest greatest version by kokas
//v5.1 10-23-06 added bollinger filter, micro account by cturner
//v5.2 10-24-06 added logic to catch and fix 1 of the 2 trades not being placed due to error
//v5.3 10-24-06 correlation logic built in by Nicholishen  
//v5.4 10-24-06 bug fixes on open orders by cturner
//v5.5 10-30-06 added short/long option that was missing by cturner
//v5.6 10-30-06 added Autotrade, to stop entering automatic after exit, by kokas
//v5.7 31-10-06 MM routine corrected, by kokas (fully support of micro accounts)
//v5.8 05-11-06 AutoTakeProfit as a percentage of AccountBalance()
//v5.9 20-11-06 eMail Notification on close orders, UsePips including Swap, AutoProfit using Bollinger
//v6.0 06-01-06 Add in Stevensign's suggestion of calcuting ratio using Pips and Range. Modify MM. BY bodshyipmonitor@forex-tsd
//v6.1 Modifications made by sbwent@forex-tsd
//v6.1 07-02-07 Added AutoMaxLoss as a multiple of ProfitTarget. ie ProfitTarget X 4
//v6.1 07-02-07 Added an option to enter manual MaxLoss when AutoMaxLoss is False.
//v6.1 07-02-07 Modified AutoProfit. If MM is switched False it works as before. If MM is ON it will calculate a ProfitTarget value
//v6.1 07-02-07 When AutoProfit is False there is an option to enter your own ProfitTarget manually
//v6.1 07-02-07 Added feature to open more trades (microlots) as a percentage of available free margin. eg 1% per day up to max of say 10 open trades. Nominate which hour each day for AutoTrades ie. 23:00
//v6.1 07-02-07 Chart displays proposed daily trade lots for 1 hour before trades are executed. Gives you time to change of disable if required.
//v6.1 07-02-07 Added an option to turn off chart display details. When False it will only display number of open trades and Net Balance.
//   
//   To do List:
//   
//   - AutoRatio Include Correlation
//   - Trailling for the hedge
//    FROM Forex-TSD. 
//    1. Modify the autoration section to utilize Stevensign's suggestions. (DONE BY bodshyipmonitor@forex-tsd)
//    2. MM - implement ratio in order to keep the hedge in balance wrt to margin requirments.
//    3. Possibly add code to allow the EA to utilyze SWAP to continually open small positions. *** Done in v6.1 by sbwent ***
//    4. "Fix" BB in order to allow traders to utilize this function with different currency pairs.
//    5. Learn more about how to interpret the "net P/L" between the two pairs in order to improve success potential when new trades are opened. (i.e. do we open when correlation is high or near zero? How is correlation related to this net P/L?)
//   


#property copyright "Copyright  2006, ForexForums.org"
#property link      "http://www.forexforums.org/"

#include <stdlib.mqh>

//---- input parameters
extern string     eaname           = "HedgeEA_v6.1";                // Expert Name and first part of comment line
extern int        Magic            = 1000;                          // Magic Number ( 0 - for All positions)
extern bool       StopManageAcc   = false;                         // Close All Trades Now
extern bool       Autotrade        = true;                          // Set to false to prevent an entry after an exit
extern bool       DisplayValues    = true;
extern bool       AccountIsMicro   = true;                          // Set true if you use a micro account
extern bool       MoneyManagement  = true;
extern bool       UsePips          = false;
extern bool       UseSwap          = true;                          // Select true if you want to use swap on profit calculation

extern string     Symbol1          = "GBPJPY";
extern bool       Symbol1isLong    = true;                          // Set to true to put long orders on the second pair
extern string     Symbol2          = "CHFJPY";
extern bool       Symbol2isLong    = false;                         // Set to true to put long orders on the second pair
extern string     Lotsizes         = "Set Ratio to 1 to use equal";
extern double     Lots             = 0.01;                           // Lots for first pair if MM is turned off

extern bool       UseAutoRatio     = true;
extern double     Ratio            = 1.6;                           // Ratio between the two pairs if UseAutoRatio = false

extern bool       AutoMaxLoss  = false;   // Added in version 6.1 to take losses
extern int        AutoMaxLossRatio = 4;  //Ratio against the Profit Target. ie ProfitTarget x 4
extern double     MaxLoss=0;            // Added in v6.1 Manual maxLoss if AutoMaxLoss=False. Setting this value will calculate all open trades and close if maximum loss is reached.

extern string     Data             = "Correlation Settings";
extern bool       UseCorrelation   = false;                         // Set to true if you want to use correlation as an entry signal
extern int        cPeriod          = 20;                            // If the correlation is used to check before put new Orders 
extern double     MinCorrelation   = 0.8; 
extern double     MaxCorrelation   = 1.0;
extern double     SMA_Value_for_Range = 200;
extern string     Data2            = "Bollinger Band Settings";
extern double     Bollinger_Period = 20;                           // Period must be in minutes
extern double     Bollinger_TF     = 60;
extern double     Bollinger_Dev    = 2;
extern bool       UseBollinger     = true;                         // Set to true to use Bollinger bands as an entry signal
extern string     Bollinger_Symbol = "GBPCHF";



extern bool       AutoProfit  = true;  // Calculates to Auto Take Profit
extern double     AutoProfitRatio  = 1;
extern double     ProfitTarget=0;    // Added in v6.1 Setting this value will calculate all open trades and close if profit reached if AutoProfit=false

extern string     DailyLotsTrading  =  "Daily Lots Trading";
extern bool       AddDailyLots = true;  // When true daily lots are added until profit is reached or max autolots added
extern bool       DailyLotsMoneyManagement = true; // Automatically calculates daily lots size
extern int        HourToAddNewLots  = 23;
extern double     DailyLots = 0.01;  // Size of auto daily lots if Daily Lots Money Manager is switched off
extern int        MaxPositions = 10;  //Multiple of 2
extern double     AutoDailyLotsRisk = 1;  //Percentage of available margin to use for adding daily lots
extern double     Risk  = 5;      // Risk Percentage
extern bool       EmailReport = false;
             

string comment = "";
string eBody = "";
string eSubject = "";
string TradeSymbol ="";
int totalPips=0;
double  totalProfits=0;
double BandsLower = 0;
double BandsUpper = 0;
bool CloseSignal=false;
bool signal1=true;
bool signal2=true;
bool OkToOrder = false;
double valueswap = 0;
double Correlation;
double Bands;
double OrderLots1, OrderLots2, NewOrderLots1,NewOrderLots2;
double AccountSize;
double Total_Lots, NewTotal_Lots;
int ticket1=0
   ,ticket2=0
   ,Symbol1SP
   ,Symbol2SP
   ,Order1=0
   ,Order2=0
   ,Ratio1=1
   ,Ratio2=1
   ,c1=0
   ,c2=0
   ,Symbol1OP
   ,Symbol2OP
   ,numords=0
   ,retry1=0
   ,retry2=0
   ;

string Direction1="";
string Direction2="";

double Symbol1Price=0, Symbol2Price=0;
double pp=0, pBid=0, volatility=0, v1=0;
int Symbol1Mode, Symbol2Mode;
int DailyOrder1=0, DailyOrder2=0;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 

   //____________________________________________________________________________________________         
   if(Symbol1isLong){Symbol1OP=OP_BUY;}
   else           {Symbol1OP=OP_SELL;}
   
   if(Symbol2isLong){Symbol2OP=OP_BUY;}
   else           {Symbol2OP=OP_SELL;}
   //____________________________________________________________________________________________ 
   //CloseSignal=false;
//----
   return(0);
  }

// ---- Scan Open Trades
int ScanOpenTrades()
{   
           
   Order1=0;Order2=0;  
   int total = OrdersTotal();
   int numords = 0;
   for(int cnt=0; cnt<=total-1; cnt++)
   {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    //if(OrderMagicNumber()==Magic)
    if(Magic > 0) if(OrderMagicNumber() == Magic) numords++;
    {
    if(OrderType()==Symbol1OP && OrderMagicNumber() == Magic && OrderSymbol()==Symbol1)Order1  += 1;
    if(OrderType()==Symbol2OP && OrderMagicNumber() == Magic && OrderSymbol()==Symbol2)Order2  += 1;
    }    
   }

   return(numords);
}

//+--------- --------- --------- --------- --------- --------- ----+
//+ Calculate cost in USD of 1pip of given symbol
//+--------- --------- --------- --------- --------- --------- ----+
double PipCost (string TradeSymbol) {
double Base, Cost;
string TS_13, TS_46, TS_4L;

TS_13 = StringSubstr (TradeSymbol, 0, 3);
TS_46 = StringSubstr (TradeSymbol, 3, 3);
TS_4L = StringSubstr (TradeSymbol, 3, StringLen(TradeSymbol)-3);

Base = MarketInfo (TradeSymbol, MODE_LOTSIZE) * MarketInfo (TradeSymbol, 
MODE_POINT);
if ( TS_46 == "USD" )
Cost = Base;
else if ( TS_13 == "USD" )
Cost = Base / MarketInfo (TradeSymbol, MODE_BID);
else if ( PairExists ("USD"+TS_4L) )
Cost = Base / MarketInfo ("USD"+TS_4L, MODE_BID);
else
Cost = Base * MarketInfo (TS_46+"USD" , MODE_BID);

return(Cost) ;
}

//+--------- --------- --------- --------- --------- --------- ----+
//+ Returns true if given symbol exists
//+--------- --------- --------- --------- --------- --------- ----+
bool PairExists (string TradeSymbol) {
return ( MarketInfo (TradeSymbol, MODE_LOTSIZE) > 0 );
}


// Generate Comment on OrderSend 
string GenerateComment(string ExpertName, int Magic)
{
   return (StringConcatenate(ExpertName, "-", Magic));
}

// Closing of Open Orders      
void OpenOrdClose()
{
    int total=OrdersTotal();
    for (int cnt=0;cnt<total;cnt++)
    { 
    OrderSelect(cnt, SELECT_BY_POS);   
    int mode=OrderType();
    bool res = false; 
    bool condition = false;
    if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
    else if ( Magic==0 ) condition = true;
      if (condition && ( mode==OP_BUY || mode==OP_SELL ))
      { 
         if (EmailReport) SendMail(eSubject,eBody);
// - BUY Orders         
         if(mode==OP_BUY)
         {  
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),3,Yellow);
            if( !res )
            {
            Print(" BUY: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;
         }
         else     
// - SELL Orders          
         if( mode == OP_SELL)
         {
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),3,White);
                
            if( !res )
            {
            Print(" SELL: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;    
         }  
      }                  
   }
}

void TotalProfit()
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {               
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((Bid-OrderOpenPrice())/Point);
            totalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((OrderOpenPrice()-Ask)/Point);
            totalProfits += OrderProfit();
            break;
         }
      }            
	}
}

void SwapProfit()
{
   int total=OrdersTotal();
   valueswap = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {      
      if (UsePips){
      valueswap = valueswap + OrderSwap()/PipCost(OrderSymbol());
      } else {
      valueswap = valueswap + OrderSwap();      
      }   
      }            
	}
}

void ChartComment()
{
   string sComment   = "";
   string sp         = "****************************\n";
   string NL         = "\n";

   if(Symbol1isLong == true) Direction1 = "--> Long"; else Direction1 = "--> Short";
   if(Symbol2isLong == true) Direction2 = "--> Long"; else Direction2 = "--> Short";

 if (DisplayValues == true){
      
      sComment = sp;
      sComment = sComment + "Open Positions  = " + ScanOpenTrades() +NL;
      
      if (Hour() == HourToAddNewLots -1 && ScanOpenTrades() > 0 && ScanOpenTrades() >= MaxPositions)
         {
            sComment = sComment + "Open Positions Limit of " + MaxPositions + " has been reached" +NL;
         }
      sComment = sComment + "Current Ratio          = " + DoubleToStr(Ratio,2) + NL;
          
      if(ScanOpenTrades() ==0){
      sComment = sComment + Symbol1 + " Price = "+ DoubleToStr(Symbol1Price,4) + ".  Lots = " + DoubleToStr(OrderLots1,2) + "  " + Direction1 + NL;
      sComment = sComment + Symbol2 + " Price = "+ DoubleToStr(Symbol2Price,4) + ".  Lots = " + DoubleToStr(OrderLots2,2) + "  " + Direction2 + NL;
      }
      
      if (Hour() == HourToAddNewLots -1 && ScanOpenTrades() > 0 && ScanOpenTrades() < MaxPositions){
      sComment = sComment + "*** New Order Lots to Open at " + HourToAddNewLots + ":00 ***" + NL;
      sComment = sComment + Symbol1 + " Price = "+ DoubleToStr(Symbol1Price,4) + ".  Lots = " + DoubleToStr(NewOrderLots1,2) + "  " + Direction1 + NL;
      sComment = sComment + Symbol2 + " Price = "+ DoubleToStr(Symbol2Price,4) + ".  Lots = " + DoubleToStr(NewOrderLots2,2) + "  " + Direction2 + NL + NL;
      }
   
   if (UsePips) {
     sComment = sComment + "Current Profit(Pip)= " + totalPips + NL;
   } else {
     sComment = sComment + "Current Profit(USD) = $" + DoubleToStr(totalProfits,2) + NL + NL; 
   }
   
   if(UseCorrelation){sComment = sComment + "Correlation              = " + DoubleToStr(Correlation,3) + NL + NL;}
   if(UseBollinger){sComment = sComment + "Bollinger Middle           = " + DoubleToStr(Bands,4) + NL;} 
   if(UseBollinger){sComment = sComment + "Bollinger Pair Price       = " + DoubleToStr(MarketInfo(Bollinger_Symbol,MODE_ASK),4) + NL + NL;}
   if(ProfitTarget>0) sComment = sComment + "Profit Target           = $"+ DoubleToStr(ProfitTarget,2) + NL;
   if(MaxLoss > 0) sComment = sComment + "Maximum Loss        = $-" + DoubleToStr(MaxLoss,2) + NL;
   
   if(UseSwap){
          sComment = sComment + "SWAP Enabled" + NL;
       } else {
          sComment = sComment + "SWAP Disabled" + NL;
       }
   
   if (UsePips) {
     sComment = sComment + "SWAP Value (Pip)= " + DoubleToStr(valueswap,2) + NL;
   } else {
     sComment = sComment + "SWAP Value (USD) = $" + DoubleToStr(valueswap,2) + NL;
   }
   
   if (UsePips) {
     sComment = NL + sComment + "Net Value (Pip)       = " + DoubleToStr(totalPips+valueswap,2) + NL;
   } else {
     sComment = NL + sComment + "Net Value (USD)     = $" + DoubleToStr(totalProfits+valueswap,2) + NL;
     sComment = sComment + NL + sp;
   }
   
   }
   else{
      sComment = sp;
      sComment = sComment + "Open Positions = " + ScanOpenTrades() +NL;
      sComment = NL + sComment + "Net Value       = $" + DoubleToStr(totalProfits+valueswap,2) + NL; 
      sComment = sComment + sp;
      Comment(sComment);
   }
   
   

   eSubject = "Hedge Profit:" + DoubleToStr(totalProfits+valueswap,2);
   eBody    = "HedgeEA Report" + NL + sComment;
   
   Comment(sComment);
}	  

double CorrelationIND(string Symbol1,string Symbol2,int CorrelationShift=0){
   double Correlation[],DiffBuffer1[],DiffBuffer2[],PowDiff1[],PowDiff2[];
   ArrayResize(Correlation,cPeriod*2);ArrayResize(DiffBuffer1,cPeriod*2);
   ArrayResize(DiffBuffer2,cPeriod*2);ArrayResize(PowDiff1,cPeriod*2);ArrayResize(PowDiff2,cPeriod*2);
   for( int shift=cPeriod+1; shift>=0; shift--){
      DiffBuffer1[shift]=iClose(Symbol1,0,shift)-iMA(Symbol1,0,cPeriod,0,MODE_SMA,PRICE_CLOSE,shift);
      DiffBuffer2[shift]=iClose(Symbol2,0,shift)-iMA(Symbol2,0,cPeriod,0,MODE_SMA,PRICE_CLOSE,shift);
      PowDiff1[shift]=MathPow(DiffBuffer1[shift],2);
      PowDiff2[shift]=MathPow(DiffBuffer2[shift],2);
      double u=0,l=0,s=0;
      for( int i = cPeriod-1 ;i >= 0 ;i--){
         u += DiffBuffer1[shift+i]*DiffBuffer2[shift+i];
         l += PowDiff1[shift+i];
         s += PowDiff2[shift+i];
      }
      if(l*s >0)Correlation[shift]=u/MathSqrt(l*s);
   }   
   return(Correlation[CorrelationShift]);
   return(-1); 
}


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   
{
  
  
  
  Correlation= CorrelationIND(Symbol1,Symbol2,0);

//added Bollinger Filter

//  Bands=iCustom(Bollinger_Symbol,Bollinger_Period,"Bands",20,0,2,0,0,0);                // Old Bollinger
  
    BandsLower = iBands(Bollinger_Symbol,Bollinger_TF,Bollinger_Period,Bollinger_Dev,0,0,2,0);          // Lower  Bollinger
    BandsUpper = iBands(Bollinger_Symbol,Bollinger_TF,Bollinger_Period,Bollinger_Dev,0,0,1,0);          // Upper  Bollinger
    Bands = (BandsLower + BandsUpper) / 2;                                                              // Middle Bollinger

   
TotalProfit();
SwapProfit();
addToMicroPositions();   
SymbolPrice();

if(AutoMaxLoss == true){
MaxLoss = ProfitTarget * AutoMaxLossRatio;

}

if(MaxLoss > 0 && AccountProfit() <= -MaxLoss){
   StopManageAcc = true;
//   Autotrade = false;
}


if (UseAutoRatio) {

     double PipRatio = PipCost(Symbol1) / PipCost(Symbol2);
     
     //Modify by bodshyipmonitor@forex-tsd. Calculate Ratio with range as well.
     //double iMA(  	string symbol, int timeframe, int period, int ma_shift, int ma_method, int applied_price, int shift)
     double Symbol1_Range= (iMA(Symbol1,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_HIGH,0)-iMA(Symbol1,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_LOW,0))/MarketInfo(Symbol1,MODE_POINT);
     double Symbol2_Range= (iMA(Symbol2,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_HIGH,0)-iMA(Symbol2,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_LOW,0))/MarketInfo(Symbol2,MODE_POINT);
     double RangeRatio = Symbol2_Range / Symbol1_Range;
     
      Ratio = PipRatio / RangeRatio; 
     }


   ChartComment();

   if (UseSwap) {
     if (UsePips) {
         totalProfits = totalPips + valueswap;
     } else {
         totalProfits = totalProfits + valueswap;
     }
     }
   // Added new Autoprofit function in v6.1. This old one still works if MM switched off.
   if (AutoProfit && !MoneyManagement) if (totalProfits > 0 && MarketInfo(Bollinger_Symbol,MODE_ASK) > BandsUpper) CloseSignal = true;
   
    

   if (!StopManageAcc)
   {
      if(ScanOpenTrades() > 0 && !CloseSignal && (ProfitTarget>0 || MaxLoss>0))
      {
        if(ProfitTarget > 0 && totalProfits>=ProfitTarget) CloseSignal=true;
        if(MaxLoss > 0 && totalProfits <= -MaxLoss) CloseSignal=true;
 
      }   
   }
   else 
   { if (ScanOpenTrades() > 0) CloseSignal=true;}    
   
   if( CloseSignal ) OpenOrdClose();

// Prepare Comment line for the trades

     if(Symbol1isLong) {
     comment = Symbol1 + "_L/"; 
     } else {
     comment = Symbol1 + "_S/";
     }
     if(Symbol2isLong) {
     comment = comment + "L_" + Symbol2;
     } else {
     comment = comment +"S_" + Symbol2;
     }
     
     comment = comment + " " + GenerateComment(eaname, Magic);
     
// Micro or Mini



     if(AccountIsMicro)  {
     
     AccountSize=2;
     
     } else {
     
     AccountSize=1;
     
     }        

// added MM statement



if(MoneyManagement) {

      
      //Modify by bodshyipmonitor@forex-tsd. Calculate Lots from Total_Lots Risk
     //OrderLots1 = NormalizeDouble(LotSize(),AccountSize); //Adjust the lot size
    // OrderLots2 = NormalizeDouble(LotSize() * Ratio,AccountSize); // change 2 to 1 for mini account
       Total_Lots=AccountFreeMargin()*Risk*0.01 *AccountLeverage()/MarketInfo(Symbol(),MODE_LOTSIZE);
       
       // Modified AutoProfit feature added in v6.1. Print option added for debugging.
       if (AutoProfit) ProfitTarget = NormalizeDouble(((OrderLots1 * PipCost(Symbol1) + OrderLots2 * PipCost(Symbol2))/2) *Risk *10* AutoProfitRatio/2,0);
       //Print("Autoprofit Target = ",ProfitTarget);
       
       OrderLots1 = NormalizeDouble(Total_Lots/(1+Ratio),AccountSize);
       OrderLots2 = NormalizeDouble(Total_Lots/(1+Ratio)*Ratio,AccountSize); 
       
     } else {
     
     OrderLots1 = Lots;
     OrderLots2 = NormalizeDouble(Lots * Ratio,AccountSize); //change 2 to 1 for mini account
   
     }
      
      
       
     
// Added signal1 that will store correlation logic if used 
     
     if(UseCorrelation) {
        if(Correlation < MaxCorrelation && Correlation > MinCorrelation) {
            signal1 = true;
        } else {
            signal1 = false;
        }
     }
     else signal1 = true; 
     
// Added signal2 that will store bollinger logic if used 
     
     if(UseBollinger) {
        if(MarketInfo(Bollinger_Symbol,MODE_ASK) < Bands) {
            signal2 = true;
        } else {
            signal2 = false;
        }
     } 
     else signal2 = true;    
     
     
// Long/Short   
     
     if((Order1==0 || Order2==0) && Symbol1isLong && !Symbol2isLong && !StopManageAcc && signal1 && signal2 && Autotrade){
    
      CloseSignal=false;
           
      if (Order1==0) {
      OrderSend(Symbol1,OP_BUY,OrderLots1,MarketInfo(Symbol1,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0) {Order1=1;}
      }
      if (Order2==0) {
      OrderSend(Symbol2,OP_SELL,OrderLots2,MarketInfo(Symbol2,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0) {Order2=1;}
      }
      }
      
// Short/Long   
     
     if((Order1==0 || Order2==0) && !Symbol1isLong && Symbol2isLong && !StopManageAcc && signal1 && signal2 && Autotrade){
    
      CloseSignal=false;
      
      if (Order1==0) {
      OrderSend(Symbol1,OP_SELL,OrderLots1,MarketInfo(Symbol1,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0) {Order1=1;}
      }
      if (Order2==0) {
      OrderSend(Symbol2,OP_BUY,OrderLots2,MarketInfo(Symbol2,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0) {Order2=1;}
      }
      }
  

// Short/Short


     if((Order1==0 || Order2==0) && !Symbol1isLong && !Symbol2isLong && !StopManageAcc && signal1 && signal2 && Autotrade){
    
      CloseSignal=false;
      
      if (Order1==0) {
      OrderSend(Symbol1,OP_SELL,OrderLots1,MarketInfo(Symbol1,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0) {Order1=1;}
      }
      if (Order2==0) {
      OrderSend(Symbol2,OP_SELL,OrderLots2,MarketInfo(Symbol2,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0) {Order2=1;}
      }
      }
      
      
      
// Long/Long

     if((Order1==0 || Order2==0) && Symbol1isLong && Symbol2isLong && !StopManageAcc && signal1  && signal2 && Autotrade){
    
      CloseSignal=false;
      
      if (Order1==0) {
      OrderSend(Symbol1,OP_BUY,OrderLots1,MarketInfo(Symbol1,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0) {Order1=1;}
      }
      if (Order2==0) {
      OrderSend(Symbol2,OP_BUY,OrderLots2,MarketInfo(Symbol2,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0) {Order2=1;}
      }

   
   }
              
 return(0);
}//int start
//+------------------------------------------------------------------+


bool checkIfOkToOrder()
{
  if(DailyOrder1==1 && DailyOrder2==1 && retry1==0 && retry2==0)
   {
      DailyOrder1=0;
      DailyOrder2=0;
   } 
  
  if (Hour() == HourToAddNewLots && ScanOpenTrades() < MaxPositions)
  {
    if (OkToOrder)
    {
      OkToOrder = false;
      return(true);
    }
    else
    {
      return(false);
    }
  }
  else
  {
    OkToOrder = true; 
    return(false);
  }
}


void addToMicroPositions()
{
NewTotal_Lots = 0;

  if (UseAutoRatio) {

    double Symbol1_Range= (iMA(Symbol1,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_HIGH,0)-iMA(Symbol1,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_LOW,0))/MarketInfo(Symbol1,MODE_POINT);
    double Symbol2_Range= (iMA(Symbol2,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_HIGH,0)-iMA(Symbol2,0,SMA_Value_for_Range,0,MODE_SMA,PRICE_LOW,0))/MarketInfo(Symbol2,MODE_POINT);
         
    double TotalRange = Symbol1_Range + Symbol2_Range;
     
     Ratio1 = (1 / PipCost(Symbol1))* (Symbol1_Range / TotalRange) /MarketInfo(Symbol1,MODE_LOTSIZE); 
     Ratio2 = (1 / PipCost(Symbol2))* (Symbol2_Range / TotalRange) /MarketInfo(Symbol2,MODE_LOTSIZE);
     }
     
     if(AccountIsMicro)  {AccountSize=2;} else {AccountSize=1;}        

 if(DailyLotsMoneyManagement) {
       NewTotal_Lots=AccountFreeMargin()*AutoDailyLotsRisk*0.01 *AccountLeverage()/MarketInfo(Symbol(),MODE_LOTSIZE);
       
       NewOrderLots1 = NormalizeDouble(NewTotal_Lots/(1+Ratio),AccountSize);
       NewOrderLots2 = NormalizeDouble(NewTotal_Lots/(1+Ratio)*Ratio,AccountSize); 
       
     } else{
     
     
     NewOrderLots1 = DailyLots;
     NewOrderLots2 = NormalizeDouble(DailyLots * Ratio,AccountSize); //change 2 to 1 for mini account
}   
     // Added Printing for debugging in v6.1
      //Print("New Order Lots: ",NewOrderLots1,", ",NewOrderLots2);
      //Print("Total Lots: ",NewTotal_Lots);      
      
           
     ChartComment();
    
     
     // * * * * * * * * * *  Placing Orders * * * * * * * * * * 
          
           
     if(!StopManageAcc && Autotrade && !CloseSignal && AddDailyLots && checkIfOkToOrder() || retry1>0 || retry2>0){
                 
     CloseSignal=false;
     
     
     // Long/Short   
     
     if((DailyOrder1==0 || DailyOrder2==0) && Symbol1isLong && !Symbol2isLong && !StopManageAcc && AddDailyLots){
    
      CloseSignal=false;
           
      if (DailyOrder1==0) {
      OrderSend(Symbol1,OP_BUY,NewOrderLots1,MarketInfo(Symbol1,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0)
               {DailyOrder1=1;
               retry1=0;
               }
            else
               {
                  DailyOrder1=0;
                  retry1=retry1+1;
                  Print("Daily Order 1 Failed with error code:",GetLastError());
               }
      }
      if (DailyOrder2==0) {
      OrderSend(Symbol2,OP_SELL,NewOrderLots2,MarketInfo(Symbol2,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0) 
            {DailyOrder2=1;
               retry2=0;
               }
         else
               {
                  DailyOrder2=0;
                  retry2=retry2+1;
                  Print("Daily Order 2 Failed with error code:",GetLastError());
               }  
      }
      }
      
// Short/Long   
     
     if((DailyOrder1==0 || DailyOrder2==0) && !Symbol1isLong && Symbol2isLong && !StopManageAcc && AddDailyLots){
    
      CloseSignal=false;
      
      if (DailyOrder1==0) {
      OrderSend(Symbol1,OP_SELL,OrderLots1,MarketInfo(Symbol1,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0)
               {DailyOrder1=1;
               retry1=0;
               }
            else
               {
                  DailyOrder1=0;
                  retry1=retry1+1;
                  Print("Daily Order 1 Failed with error code:",GetLastError());
               }
      }
      if (DailyOrder2==0) {
      OrderSend(Symbol2,OP_BUY,NewOrderLots2,MarketInfo(Symbol2,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0) 
            {DailyOrder2=1;
               retry2=0;
               }
         else
               {
                  DailyOrder2=0;
                  retry2=retry2+1;
                  Print("Daily Order 2 Failed with error code:",GetLastError());
               }  
      }
      }
  

// Short/Short


     if((DailyOrder1==0 || DailyOrder2==0) && !Symbol1isLong && !Symbol2isLong && !StopManageAcc && AddDailyLots){
    
      CloseSignal=false;
      
      if (DailyOrder1==0) {
      OrderSend(Symbol1,OP_SELL,OrderLots1,MarketInfo(Symbol1,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0)
               {DailyOrder1=1;
               retry1=0;
               }
            else
               {
                  DailyOrder1=0;
                  retry1=retry1+1;
                  Print("Daily Order 1 Failed with error code:",GetLastError());
               }
      }
      if (DailyOrder2==0) {
      OrderSend(Symbol2,OP_SELL,NewOrderLots2,MarketInfo(Symbol2,MODE_BID),3,0,0,comment,Magic,0,Red);
      if (GetLastError()==0) 
            {DailyOrder2=1;
               retry2=0;
               }
         else
               {
                  DailyOrder2=0;
                  retry2=retry2+1;
                  Print("Daily Order 2 Failed with error code:",GetLastError());
               }  
      }
      }
      
      
      
// Long/Long

     if((DailyOrder1==0 || DailyOrder2==0) && Symbol1isLong && Symbol2isLong && !StopManageAcc && AddDailyLots){
    
      CloseSignal=false;
      
      if (DailyOrder1==0) {
      OrderSend(Symbol1,OP_BUY,NewOrderLots1,MarketInfo(Symbol1,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0)
               {DailyOrder1=1;
               retry1=0;
               }
            else
               {
                  DailyOrder1=0;
                  retry1=retry1+1;
                  Print("Daily Order 1 Failed with error code:",GetLastError());
               }
      }
      if (DailyOrder2==0) {
      OrderSend(Symbol2,OP_BUY,NewOrderLots2,MarketInfo(Symbol2,MODE_ASK),3,0,0,comment,Magic,0,Blue);
      if (GetLastError()==0) 
            {DailyOrder2=1;
               retry2=0;
               }
         else
               {
                  DailyOrder2=0;
                  retry2=retry2+1;
                  Print("Daily Order 2 Failed with error code:",GetLastError());
               }  
      }
}
     
     
     
     
     
     
     // New feature added in v6.1
     /***** Could not get this to open all trades consistantly. occasionally only opens 1 trade or none.*********
      
      // Order1
      
      if (DailyOrder1==0) {
         OrderSend(Symbol1,Symbol1OP,NewOrderLots1,MarketInfo(Symbol1,Symbol1Mode),3,0,0,comment,Magic,0,Blue);
            if (GetLastError()==0)
               {DailyOrder1=1;}
            else
               {
                  DailyOrder1=0;
                  Print("Daily Order 1 Failed with error code:",GetLastError());
               }
      }
            
      // Order2
      
      if (DailyOrder2==0) {
      OrderSend(Symbol2,Symbol2OP,NewOrderLots2,MarketInfo(Symbol2,Symbol2Mode),3,0,0,comment,Magic,0,Blue);
         if (GetLastError()==0) 
            {DailyOrder2=1;}
         else
               {
                  DailyOrder2=0;
                  Print("Daily Order 2 Failed with error code:",GetLastError());
               }   
            
      }*/
  
   }

}

void SymbolPrice()
{
   
      
      pp = MarketInfo(Symbol1, MODE_POINT); 
      pBid = MarketInfo(Symbol1, MODE_ASK); 
      Symbol1Price = pBid;

      pp = MarketInfo(Symbol2, MODE_POINT); 
      pBid = MarketInfo(Symbol2, MODE_ASK);
      Symbol2Price = pBid;         
}